print("TechSatellitesRevealCities.lua")

local iFeatureFallout = GameInfo.Features["FEATURE_FALLOUT"].ID

function revealCities()
  local iTeam = Game.GetActiveTeam()
  local pTeam = Teams[iTeam]
  local pPlot
  local pCity

  if (citiesVisible(pTeam)) then
    for iPlotLoop = 0, Map.GetNumPlots()-1, 1 do
		pPlot = Map.GetPlotByIndex(iPlotLoop)

		if (pPlot:IsCity()) then
			pCity = pPlot:GetPlotCity()
			if (pCity:GetTeam() ~= iTeam) then
				--if (iKeyhole > 0) then
				--	revealCell(iTeam, pPlot)
				--else
				revealPlot(iTeam, pPlot)
				--end
			end
		end
    end
  end
end

function citiesVisible(pTeam)
	local iKeyhole = pTeam:GetProjectCount(GameInfo.Projects["PROJECT_KEYHOLE_PROJECT"].ID)
	if (iKeyhole > 0) then
		return true
	else
		return false
	end
end


function revealCell(iTeam, pPlot)
  directions = {DirectionTypes.DIRECTION_NORTHEAST, DirectionTypes.DIRECTION_EAST, DirectionTypes.DIRECTION_SOUTHEAST,
                DirectionTypes.DIRECTION_SOUTHWEST, DirectionTypes.DIRECTION_WEST, DirectionTypes.DIRECTION_NORTHWEST}

  -- Reveal the central plot
  revealPlot(iTeam, pPlot)

  -- Reveal the surrounding plots
  for loop, direction in ipairs(directions) do
	revealPlot(iTeam, Map.PlotDirection(pPlot:GetX(), pPlot:GetY(), direction))
  end
end

function revealPlot(iTeam, pPlot)
  -- Don't reveal natural wonders more than once
  if (pPlot:GetFeatureType() <= iFeatureFallout) then
    -- Following lines copied from the Live Tuner Map tab script
    if (pPlot:GetVisibilityCount(iTeam) > 0) then
		pPlot:ChangeVisibilityCount(iTeam, -1, -1, true)
    end

    pPlot:SetRevealed(iTeam, false)

    pPlot:ChangeVisibilityCount(iTeam, 1, -1, true)
    pPlot:SetRevealed(iTeam, true)
  end
end

function onActivePlayerTurnStart()
	revealCities()
end

Events.ActivePlayerTurnStart.Add(onActivePlayerTurnStart)
