-------------------------------------------------
-- Economic
-------------------------------------------------

include( "IconSupport" );

local m_CurrentPanel = Controls.EconomicGeneralInfo;

-- REALISM MOD START
local tCities = {};

function UpdateList()
	tCities = {};
	local pPlayer = Players[ Game.GetActivePlayer() ];
	for pCity in pPlayer:Cities() do
		local iArea = pCity:Area():GetID();
		local sList = pPlayer:GetStrListCitiesColony(iArea);
		local v = {id = -1, Cities = ""};
		if (sList ~= "") then
			local bAdd = true;
			for i,l in ipairs(tCities) do
				if (l.id == iArea) then
					bAdd = false;
				end;
			end;
			if (bAdd) then
				v.id = iArea;
				v.Cities = sList;
				table.insert(tCities, v);
			end;
		end;
	end;
end

function UpdateCreateColonyButton()
	print("UpdateCreateColonyButton");
	
    local pPlayer = Players[ Game.GetActivePlayer() ];
    if( pPlayer == nil ) then
        print( "Could not get player... huh?" );
        return;
    end
	
	if (Game.IsOption("GAMEOPTION_NO_VASSALAGE")) then
		Controls.CreateColony:SetDisabled(true);
		Controls.CreateColony:LocalizeAndSetToolTip("TXT_KEY_TOOLTIP_CREATE_COLONY_NO_VASSALAGE");
	end
	
	
	UpdateList();
	local bShow = false;
	local strListCities = Locale.Lookup("TXT_KEY_TOOLTIP_CREATE_COLONY_1");
	for i,v in ipairs(tCities) do
		strListCities = strListCities .. "[NEWLINE][ICON_BULLET] " .. v.Cities;
		bShow = true;
	end;
	

	if (bShow) then
		Controls.CreateColony:SetDisabled(false);
		Controls.CreateColony:SetToolTipString(strListCities);
	else
		Controls.CreateColony:SetDisabled(true);
		if (not Teams[pPlayer:GetTeam()]:IsVassalageTradingAllowed()) then
			Controls.CreateColony:LocalizeAndSetToolTip("TXT_KEY_TOOLTIP_CREATE_COLONY_2");
		elseif (Teams[pPlayer:GetTeam()]:IsVassalOfSomeone()) then
			Controls.CreateColony:LocalizeAndSetToolTip("TXT_KEY_TOOLTIP_CREATE_COLONY_4");
		else
			Controls.CreateColony:LocalizeAndSetToolTip("TXT_KEY_TOOLTIP_CREATE_COLONY_3", pPlayer:GetMinCitiesForCreatingColony());
		end
	end
end

local instance = {};
function OnCreateColonyClick()
	print("OnCreateColonyClick");
	
	local pPlayer = Players[ Game.GetActivePlayer() ];
	if( pPlayer == nil ) then
		print( "Could not get player... huh?" );
		return;
	end
	
	CivIconHookup( Game.GetActivePlayer(), 64, Controls.CivIcon1, Controls.CivIconBG1, Controls.CivIconShadow1, false, true );
	
	UpdateList();
	
	local strListCities = Locale.Lookup("TXT_KEY_TOOLTIP_CREATE_COLONY_1");
	local iNumButtons = 0;
	Controls.CityStack:DestroyAllChildren();
	for i,v in ipairs(tCities) do
		strListCities = strListCities .. "[NEWLINE][ICON_BULLET] " .. v.Cities;
		ContextPtr:BuildInstanceForControl( "CityInstance", instance, Controls.CityStack );
		instance.CityButton:SetText(v.Cities);
		instance.CityButton:RegisterCallback(Mouse.eLClick, function()
			local pPlayer = Players[ Game.GetActivePlayer() ];
			pPlayer:CreateColony(v.id);
			Controls.ChooseConfirm:SetHide(true);
		end);
		iNumButtons = iNumButtons + 1;
	end;
	Controls.ConfirmText:SetText( strListCities );
	
	Controls.ChooseConfirm:SetHide(false);
	
	Controls.ConfirmFrame:SetSizeY(310 + iNumButtons * 64);
end
Controls.CreateColony:RegisterCallback(Mouse.eLClick, OnCreateColonyClick);


--function OnYes()
--	print("OnYes");
--	
--	local pPlayer = Players[ Game.GetActivePlayer() ];
	
--	UpdateList();
	
--	for i,v in ipairs(tCities) do
--		pPlayer:CreateColony(v.id);
--	end;
	
--	UpdateCreateColonyButton();
--	Controls.ChooseConfirm:SetHide(true);
--end
--Controls.Yes:RegisterCallback( Mouse.eLClick, OnYes );

function OnNo()
	Controls.ChooseConfirm:SetHide(true);
end
Controls.No:RegisterCallback( Mouse.eLClick, OnNo );
-- REALISM MOD END

-------------------------------------------------
-- On Popup
-------------------------------------------------
function OnPopup( popupInfo )
	if( popupInfo.Type == ButtonPopupTypes.BUTTONPOPUP_ECONOMIC_OVERVIEW ) then
		m_PopupInfo = popupInfo;
		
		if( m_PopupInfo.Data1 == 1 ) then
        	if( ContextPtr:IsHidden() == false ) then
        	    OnClose();
        	    return;
    	    else
            	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
        	end
    	else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.EconOverview );
    	end
	end
end
Events.SerialEventGameMessagePopup.Add( OnPopup );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose()
    UIManager:DequeuePopup( ContextPtr );
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose);


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
            OnClose();
            return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    local pPlayer = Players[ Game.GetActivePlayer() ];
    if( pPlayer == nil ) then
        print( "Could not get player... huh?" );
        return;
    end
    
	-- Set Civ Icon
	CivIconHookup( Game.GetActivePlayer(), 64, Controls.CivIcon, Controls.CivIconBG, Controls.CivIconShadow, false, true );

	-- REALISM MOD START
	UpdateCreateColonyButton();
	-- REALISM MOD END
	
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	
        	-- trigger the show/hide handler to update state
        	m_CurrentPanel:SetHide( false );
        	
        	Events.SerialEventGameMessagePopupShown(m_PopupInfo);
        else
            UI.decTurnTimerSemaphore();
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_ECONOMIC_OVERVIEW, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnGeneralInfoButton()
	-- Set Tabs
	Controls.GeneralInfoSelectHighlight:SetHide(false);
	Controls.HappinessSelectHighlight:SetHide(true);
	
	-- Set Panels
    Controls.EconomicGeneralInfo:SetHide( false );
    Controls.HappinessInfo:SetHide( true );
    m_CurrentPanel = Controls.EconomicGeneralInfo;
end
Controls.GeneralInfoButton:RegisterCallback( Mouse.eLClick, OnGeneralInfoButton );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnHappinessButton()
	-- Set Tabs
	Controls.GeneralInfoSelectHighlight:SetHide(true);
	Controls.HappinessSelectHighlight:SetHide(false);
	
	-- Set Panels
    Controls.EconomicGeneralInfo:SetHide( true );
    Controls.HappinessInfo:SetHide( false );
    m_CurrentPanel = Controls.HappinessInfo;
end
Controls.HappinessButton:RegisterCallback( Mouse.eLClick, OnHappinessButton );


OnGeneralInfoButton();

-- Disable Happiness section if Happiness is turned off.
if (Game.IsOption(GameOptionTypes.GAMEOPTION_NO_HAPPINESS)) then
	Controls.HappinessButton:SetDisabled(true);
	Controls.HappinessButton:LocalizeAndSetToolTip("TXT_KEY_TOP_PANEL_HAPPINESS_OFF_TOOLTIP");
end

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
Events.GameplaySetActivePlayer.Add(OnClose);